//------------------------------------------------------------------
//
//    original idea and tradestation code by John Ehlers
//    this version by mladen
//
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_level1 0

//
//
//
//
//

extern int    BandPassPeriod = 50;
extern int    BandPassPrice  = PRICE_MEDIAN;
extern double Delta          = 0.1;

double bp[];
double bpHuu[];
double bpHud[];
double bpHdd[];
double bpHdu[];
double prices[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(7);
      SetIndexBuffer(0,bpHuu); SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1,bpHud); SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(2,bpHdd); SetIndexStyle(2, DRAW_HISTOGRAM);
      SetIndexBuffer(3,bpHdu); SetIndexStyle(3, DRAW_HISTOGRAM);
      SetIndexBuffer(4,bp);
      SetIndexBuffer(5,prices);
      SetIndexBuffer(6,slope);
      IndicatorShortName("Band pass "+BandPassPeriod+","+DoubleToStr(Delta,2)+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.141592653589793238462643383279
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      double beta    = MathCos(2.0*Pi/BandPassPeriod);
      double gamma   = 1.0 / MathCos(4.0*Pi*Delta/BandPassPeriod);
      double alpha   = gamma -MathSqrt(gamma*gamma-1.0);
   
      //
      //
      //
      //
      //
      
      for(int i=limit; i>=0; i--)
      {
         prices[i] = iMA(NULL,0,1,0,MODE_SMA,BandPassPrice,i);
         bp[i]      = 0.5*(1.0-alpha)*(prices[i]-prices[i+2])+beta*(1.0+alpha)*bp[i+1]-alpha*bp[i+2];
         
         //
         //
         //
         //
         //
         
         bpHuu[i] = EMPTY_VALUE;
         bpHud[i] = EMPTY_VALUE;
         bpHdd[i] = EMPTY_VALUE;
         bpHdu[i] = EMPTY_VALUE;
         slope[i] = slope[i+1];
            if (bp[i]>bp[i+1]) slope[i] =  1;
            if (bp[i]<bp[i+1]) slope[i] = -1;
            if (bp[i]>0)
            if (slope[i]==1)
                  bpHuu[i] = bp[i];
            else  bpHud[i] = bp[i];
            if (bp[i]<0)
            if (slope[i]==1)
                  bpHdu[i] = bp[i];
            else  bpHdd[i] = bp[i];
      }               
      return(0);
}